program FreeOTFEExplorer_Launcher;

uses
  Forms, Windows, SysUtils,
  Dialogs,
  SDUGeneral,
  SDUi18n,
  SDUDialogs;

{$R *.res}

{$IFDEF _NEVER_DEFINED}
// This is just a dummy const to fool dxGetText when extracting message
// information
// This const is never used; it's #ifdef'd out - SDUCRLF in the code refers to
// picks up SDUGeneral.SDUCRLF
const
  SDUCRLF = ''#13#10;
{$ENDIF}

var
  zAppName:array[0..512] of char;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  exeFilename: string;
  runExeWithPath: string;
  appDirPath: string;
  runCmdLine: string;
begin
  // This next line is required in order to allow the application icon
  Application.Initialize;

  exeFilename := ExtractFilename(paramstr(0));
  exeFilename := StringReplace(
                               exeFilename,
                               '_launcher',
                               '',
                               [rfReplaceAll, rfIgnoreCase]
                              );

  appDirPath := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0)))+'App\'+ChangeFileExt(exeFilename, '');

  runExeWithPath := appDirPath+'\'+exeFilename;

  if not(FileExists(runExeWithPath)) then
    begin
    SDUMessageDlg(
                  _('Executable:'+SDUCRLF+
                  SDUCRLF+
                  runExeWithPath+SDUCRLF+
                  SDUCRLF+
                  'not found.',
                  ),
                  mtError
                 );
    end
  else
    begin
    runCmdLine := runExeWithPath + ' -settings ..\..\Data\'+ChangeFileExt(exeFilename, '.ini');

    StrPCopy(zAppName, runCmdLine);
    FillChar(StartupInfo, Sizeof(StartupInfo), #0);
    StartupInfo.cb := Sizeof(StartupInfo);

    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow := SW_NORMAL;

    if CreateProcess(
                     nil,
                     zAppName,              { pointer to command line string }
                     nil,                   { pointer to process security attributes }
                     nil,                   { pointer to thread security attributes }
                     false,                 { handle inheritance flag }
                     CREATE_NEW_CONSOLE or  { creation flags }
                     NORMAL_PRIORITY_CLASS,
                     nil,                   { pointer to new environment block }
                     PChar(appDirPath),     { pointer to current directory name }
                     StartupInfo,           { pointer to STARTUPINFO }
                     ProcessInfo
                    ) then      { pointer to PROCESS_INF }
      begin
      CloseHandle(ProcessInfo.hProcess);
      CloseHandle(ProcessInfo.hThread);
      end;
    end;

end.
